<script setup lang="ts">
import { computed, onMounted, type PropType, ref, watch } from "vue";
import type { ExtendedColors } from "@/types/PropTypes";

const model = defineModel({ required: true });

const props = defineProps({
  parameter: {
    type: Object,
    required: true,
    validator(value: Record<string, never>) {
      return "boolean" === value["type"];
    },
  },
  border: String as PropType<ExtendedColors>,
  required: Boolean,
  id: String,
  customValidity: { type: String, required: false },
});

const helpTextPresent = computed<boolean>(() => props.parameter["help_text"]);
const iconPresent = computed<boolean>(() => props.parameter["fa_icon"]);

const trueOption = ref<HTMLInputElement | undefined>(undefined);
const falseOption = ref<HTMLInputElement | undefined>(undefined);

const dynamicCssClasses = computed<string[]>(() => {
  const cssClasses = [];
  if (props.border) {
    cssClasses.push("border", `border-${props.border}`, "bg-dark-subtle");
  }
  if (!helpTextPresent.value) {
    cssClasses.push("rounded-end");
  }
  if (!iconPresent.value) {
    cssClasses.push("rounded-start");
  }
  return cssClasses;
});

watch(model, (newVal) => {
  if (typeof newVal === "number") {
    // type conversion if true/false is represented by 0/1
    model.value = !!newVal;
  }
  /* eslint-disable @typescript-eslint/ban-ts-comment */
  // @ts-ignore
  setCustomValidity(props.required, newVal);
});

watch(
  () => props.required,
  (newVal) => {
    /* eslint-disable @typescript-eslint/ban-ts-comment */
    // @ts-ignore
    setCustomValidity(newVal, model.value);
  },
);

watch(
  () => props.customValidity,
  (newVal) => {
    if (newVal != undefined) {
      trueOption.value?.setCustomValidity(newVal);
      falseOption.value?.setCustomValidity(newVal);
    } else {
      /* eslint-disable @typescript-eslint/ban-ts-comment */
      // @ts-ignore
      setCustomValidity(props.required, model.value);
    }
  },
);

function setCustomValidity(required: boolean, value: boolean | undefined) {
  const reason = required && value == undefined ? "Unset" : "";
  trueOption.value?.setCustomValidity(reason);
  falseOption.value?.setCustomValidity(reason);
}

onMounted(() => {
  if (model.value != undefined) {
    // type conversion if true/false is represented by 0/1
    model.value = model.value ? true : false;
  }
  if (props.customValidity != undefined) {
    trueOption.value?.setCustomValidity(props.customValidity);
    falseOption.value?.setCustomValidity(props.customValidity);
  } else {
    /* eslint-disable @typescript-eslint/ban-ts-comment */
    // @ts-ignore
    setCustomValidity(props.required, model.value);
  }
});
</script>

<template>
  <div
    class="flex-fill mb-0 fs-6 d-flex align-items-center justify-content-start py-1 ps-4"
    :class="dynamicCssClasses"
  >
    <div class="form-check form-check-inline mb-0">
      <input
        :id="id + 'TrueOption'"
        ref="trueOption"
        v-model="model"
        class="form-check-input"
        type="radio"
        :name="id + 'inlineRadioOptions'"
        :value="true"
      />
      <label class="form-check-label" :for="id + 'TrueOption'">True</label>
    </div>
    <div class="form-check form-check-inline mb-0">
      <input
        :id="id + 'FalseOption'"
        ref="falseOption"
        v-model="model"
        class="form-check-input"
        type="radio"
        :name="id + 'inlineRadioOptions'"
        :value="false"
      />
      <label class="form-check-label" :for="id + 'FalseOption'">False</label>
    </div>
  </div>
</template>

<style scoped></style>
